using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using GTA;
using GTA.Math;

public class SharkCannon : Script
{
    bool toggleshark = true;        //BOOL only because there are only 2 shark types
    public SharkCannon()
    {
        Tick += OnTick; // Main loop event, called every few milliseconds specified via the Interval property.
        KeyUp += OnKeyUp; // Called when a key or mouse button is released.
        KeyDown += OnKeyDown; // Called when a key or mouse button is pressed.

        Interval = 10; // Tick interval in milliseconds. Set to zero to run as fast as possible.
    }

    void OnTick(object sender, EventArgs e)
    {

    }

    void OnKeyUp(object sender, KeyEventArgs e)
    {
        if (e.KeyCode == Keys.H)        //Every time key H is released, 
        {
            toggleshark = !toggleshark; //switch toggleshark, therefore switching between the 2 available shark models
        }
    }

    void OnKeyDown(object sender, KeyEventArgs e)
    {
        if (e.KeyCode == Keys.H)
        {
            Ped playerped = Game.Player.Character;
            GTA.Math.Vector3 SpawnLoc = playerped.Position + (playerped.ForwardVector * 5);     //initial spawn location of deadbody
            string[] sharkarray = {"a_c_sharktiger", "a_c_sharkhammer"};    //can change these to other Ped model names. The array that is looped through to spawn different Ped models
            string deadshark = sharkarray[0]; //This will be passed to CreatePed as the name of the model to spawn

            if (toggleshark)        //decides which modelname (in sharkarray) is to be spawned
            {
                deadshark = sharkarray[0];
            }
            else
            {
                deadshark = sharkarray[1];
            }

            Ped deadbody = GTA.World.CreatePed(deadshark, SpawnLoc);        //creates deadshark in game
            deadbody.CanRagdoll = true;     //not 100% sure if needed, but i put it here just in case

            GTA.Native.Function.Call(GTA.Native.Hash.SET_PED_TO_RAGDOLL, deadbody, 10000, 10000, 0, true, true, true);      //forces deadbody to ragdoll for 10000ms (10sec)
            GTA.Native.Function.Call(GTA.Native.Hash.SET_ENTITY_HEALTH, deadbody, 0);       //make deadbody actually dead
            deadbody.ApplyForce(playerped.ForwardVector * 500);     //Launch deadbody forward relative to Player model w/ force of 500
        }
    }
}